<template>
  <v-select
    v-model="model"
    :label="label"
    :disabled="disabled"
    :multiple="multiple"
    variant="outlined"
    hide-details="auto"
    :error="error"
    menu-icon="custom:mingcute:down-small-fill"
    base-color="onSurfaceVariant"
    color="primary"
    clear-icon="mdi-close"
    :items="items"
    :list-props="{
      itemProps: true,
      class: 'py-0',
    }"
    :chips="chips"
    closable-chips
    :item-title="itemTitle"
    :item-value="itemValue"
    :error-messages="errorMessages"
    @update:model-value="update"
    :clearable="withSelectAll"
    :return-object="returnObject"
  >
    <template v-if="withSelectAll" #prepend-item>
      <v-list-item
        :height="48"
        class="px-4"
        @click="toggleAll"
      >
        <template #default>
          <div class="flex items-center justify-start">
            <svn-pro-checkbox
              :indeterminate="atLeastOneSelected && !allSelected"
              :value="!allSelected"
            />

            <svn-pro-text
              regular
              color="onSurface"
            >
              {{ `Select all (${items?.length || 0})` }}
            </svn-pro-text>
          </div>
        </template>
      </v-list-item>

      <v-divider class="border-opacity-100"></v-divider>
    </template>

    <template v-if="chips" #chip="{ item, index, props }">
      <svn-pro-chip
        v-bind="props"
        :text="item?.title"
        @on-close="closeAndUpdate(item?.value)"
      >
      </svn-pro-chip>
    </template>
  </v-select>
</template>

<script setup>
import { ref, watch, onMounted, computed } from 'vue';
import SvnProCheckbox from './SvnProCheckbox.vue';
import SvnProText from "../styles/SvnProText.vue";
import SvnProChip from "../chip/SvnProChip.vue";

const props = defineProps({
  modelValue:{
    type: undefined,
    default: null,
  },
  label:{
    type: String,
    default: "Label",
  },
  itemTitle: {
    type: String,
    default: "title",
  },
  itemValue: {
    type: String,
    default: "value",
  },
  chips: {
    type: Boolean,
    default: false
  },
  disabled:{
    type: Boolean,
    default: false,
  },
  error:{
    type: Boolean,
    default: false,
  },
  multiple:{
    type: Boolean,
    default: false,
  },
  withSelectAll: {
    type: Boolean,
    default: false,
  },
  errorMessages:{
    type: Array,
    default: () => [],
  },
  items:{
    type: Array,
    default: () => [],
  },
  returnObject: {
    type: Boolean,
    default: false,
  },
})

const emit = defineEmits(['update:modelValue', 'clear'])

const allSelected = computed(() => {
  if (model?.value?.length === props.items?.length) {
    return true
  }
  return false
})

const atLeastOneSelected = computed(() => {
  if (model?.value?.length > 0) {
    return true
  }
  return false
})

onMounted(() => {
  model.value = props?.modelValue
});

const model = ref(null);

const toggleAll = () => {
  if (allSelected.value) {
    model.value = []
  } else {
    model.value = props.items.map(item => item?.value)
  }
  update()
}

const update = () => {
  emit('update:modelValue', model?.value)
}

const closeAndUpdate = (value) => {
  if (props?.multiple) {
    const itemInList = model?.value?.find((el => el === value))
    if (itemInList) {
      model.value = model?.value?.filter(el => el !== itemInList)
    } else {
      model.value.push(value)
    }
  } else {
    model.value = null
  }
}

watch(props, (newValue, oldValue) => {
  if (newValue.modelValue) {
    model.value = newValue.modelValue
  }
})
</script>